package Msn::Bot::Google;

# $Id: Google.pm 141 2004-08-06 00:25:11Z tea $

use strict;
use warnings;
use Carp;

use CGI::Util qw/escape/;

use Net::Google;
use constant GOOGLE_LICENSE_KEY => $ENV{GOOGLE_KEY};

my $google = Net::Google->new(key => GOOGLE_LICENSE_KEY);

sub search {
    my (@words) = @_;
    my $search = $google->search();

    $search->query( map { escape($_) } @words );
    $search->lr('lang_ja');
    $search->starts_at(0);
    $search->max_results(6);
    
    my $result = join("\n", map {
        my $title = $_->title(); $title =~ s{<.+?>}{}g;
        sprintf("%s (%s)", $title, $_->URL());
    } @{$search->results()});

    return $result;
}

sub spelling {
    my ($word) = @_;

    # TODO
    # suggest() return nothing when the phrase is correct spelling.
    return $google->spelling(phrase => $word)->suggest();
}


1;

