package Msn::Bot::Translate;

# $Id: Translate.pm 100 2004-06-06 15:18:21Z tea $

use strict;
use warnings;
use Encode qw/from_to/;
use URI;
use URI::Escape;
use LWP::UserAgent;
use HTTP::Request;

# TODO Change web service.
use constant TRANSLATE_URL => 'http://www.excite.co.jp/world/english';

my $userAgent = LWP::UserAgent->new();

sub translate {
    my ($word, $wb_lp) = @_;
    my $request = HTTP::Request->new(POST => TRANSLATE_URL);

    # XXX I had fixed the charset.
    # you may need another encoding.
    #
    # MSN Messenger    -- utf8
    # Excite translate -- ShiftJIS
    # 
    from_to($word, "utf8", "shift_jis");

    $request->push_header('Host' => URI->new(TRANSLATE_URL)->host);
    $request->content(
        sprintf("start=1&before=%s&wb_lp=$wb_lp", uri_escape($word))
    );

    my $response = $userAgent->request($request);
    if ($response->is_success) {
        my $body = $response->content;
        if ($body =~ m{<textarea[^>]+name="after"[^>]+>([^<]+)</textarea>}) {
            $word = $1;
            from_to($word, "shift_jis", "utf8");
            return $word;
        }
    }
    return undef;
}

sub J2E {
    my ($word) = @_;
    return translate($word, "JAEN");
}


sub E2J {
    my ($word) = @_;
    return translate($word, "ENJA");
}

1;
