package Msn::Message;

# $Id: Message.pm 31 2004-03-21 11:21:26Z tea $

use strict;
use warnings;
use Carp;

use base qw/Msn::Util::MIME/;

sub new {
    my ($class) = shift(@_);
    my $self = $class->SUPER::new();
    
    if (defined $_[0] and ref $_[0] eq 'SCALAR') {
        $self->parse( $_[0] );
    }
    
    return $self;
}

sub parse {
    my ($self, $buffer) = @_;

    my $pos = 0;
    my $line = "";
    
    for (;;) {
        my $tail = index($$buffer, "\n", $pos);
        last if $tail < 0;
        my $line = substr($$buffer, $pos, $tail-$pos);
        $pos = $tail + 1;

        $line =~ s/[\r\n]//g; # chomp($line); did not remove \r
        last if length($line) == 0;

        $self->setHeader(split(/: /, $line));
    }

    $self->{body} = substr($$buffer, $pos);
}

sub dumpMessage {
    my ($self) = @_;
    my $result = "";
    
    # XXX This code did not care binary encoding body.
    $self->{body} =~ s/\r//g;
    $self->{body} =~ s/\n/\r\n/;
    #$self->setHeader('Content-Length', length($self->getBody()));
    
    for my $key ($self->getHeaderKeys()) {
        $result .= sprintf("%s: %s\r\n", $key, $self->getHeader($key));
    }
    
    $result .= "\r\n";
    $result .= $self->getBody();
    $result .= "\n" unless $result =~ /\n$/; # The ending line must be "\n" ?
    $result;
}

1;

