package Msn::Message::MsnObject;

# $Id$

use strict;
use warnings;
use Carp;

use Msn::Util::UserHash;

sub new {
    my ($class, $body) = @_;
    my $self = bless({}, $class);

    $self->{data} = Msn::Util::UserHash->new();
    $self->parse($body) if defined $body;
    $self;
}

sub parse {
    my ($self, $body) = @_;
    my ($text, $object) = split(/\t/, $body, 2);

    while ($object =~ m/(\w+)=\"(.+?)\"/g) {
        $self->{data}->set($1, $2);
    }
    $self->{text} = $text;
}

sub toString {
    my ($self) = @_;

    my $string = $self->{text} . "\t" . "<msnobject";

    foreach ($self->{data}->keys()) {
        $string .= qq( $_="@{[$self->{data}->get($_)]}");
    }
    $string .= " />\t";

    return $string;
}

1;

